import javax.microedition.midlet.* ;
import javax.microedition.lcdui.* ;



public class  Config  extends Form implements  CommandListener {
	private view  vv ;
	private static final String[] list = {
		"s(0-9)","tHgTCY","c\ɕύX","sӏɋs}","펞obNCg","őǍs(1-10)","őҏW(10-120KB)",
		"FR(0-255)","FG(0-255)","FB(0-255)", "wiFR(0-255)","wiFG(0-255)","wiFB(0-255)",
		"󃁃(ύXs)","(ύXs)","lɖ߂"} ;
	private static final String[] fontstring = {"SMALL()","MEDIUM()","LARGE()"} ;
	private static final String[] yes_no = {"͂", ""} ;
	private long totalmemorysize ;
//	private int  lineh, fontsize, maxloadline, editmaxline ;
//	private int  backcolor_r, backcolor_g, backcolor_b, textcolor_r, textcolor_g, textcolor_b ;
//	private boolean paragraphenter, keepbl, tategaki ;
	private TextField  maxloadline, editmaxline;
	private Gauge  lineh, backcolor_r, backcolor_g, backcolor_b, textcolor_r, textcolor_g, textcolor_b ;
	private ChoiceGroup  fontsize, paragraphenter, keepbl, tategaki ;
	private StringItem memorysize ;

	public  Config( view v){
		super( "config");
		vv = v ;
		totalmemorysize = Runtime.getRuntime().totalMemory() ;
		addCommand( new Command( "OK", Command.SCREEN, 19)) ;
		addCommand( new Command( "CANCEL", Command.SCREEN, 18)) ;
		setCommandListener( this) ;

		maxloadline = new TextField( list[5], ""+14999, 5, TextField.NUMERIC) ;
		editmaxline = new TextField( list[5], ""+40960/1024, 3, TextField.NUMERIC) ;

		lineh = new Gauge( list[0], true, 9, 2) ;
		textcolor_r = new Gauge( list[7], true, 255, 255) ;
		textcolor_g = new Gauge( list[8], true, 255, 255) ;
		textcolor_b = new Gauge( list[9], true, 255, 255) ;
		backcolor_r = new Gauge( list[10], true, 255, 0) ;
		backcolor_g = new Gauge( list[11], true, 255, 0) ;
		backcolor_b = new Gauge( list[12], true, 255, 0) ;

		fontsize = new ChoiceGroup( list[1], Choice.POPUP, fontstring, null) ;
		paragraphenter = new ChoiceGroup( list[3], Choice.POPUP, yes_no, null) ;
		keepbl = new ChoiceGroup( list[4], Choice.POPUP, yes_no, null) ;
		tategaki = new ChoiceGroup( list[2], Choice.POPUP, yes_no, null) ;

		memorysize = new StringItem( list[13], "0") ;
		this.append( lineh);this.append( fontsize);this.append( tategaki);this.append( paragraphenter);this.append( keepbl);this.append( maxloadline);
		this.append( editmaxline);this.append( textcolor_r);this.append( textcolor_g);this.append( textcolor_b);
		this.append( backcolor_r);this.append( backcolor_g);this.append( backcolor_b);this.append( memorysize);this.append( new StringItem(list[14], ""+totalmemorysize));
	}

	public void init(){
		memorysize.setText( ""+ Runtime.getRuntime().freeMemory());

		lineh.setValue( vv.lineh-vv.font.getHeight()) ;
		textcolor_r.setValue( (vv.textcolor/65536)%256) ;
		textcolor_g.setValue( (vv.textcolor/256)%256) ;
		textcolor_b.setValue( vv.textcolor%256) ;
		backcolor_r.setValue( (vv.backcolor/65536)%256) ;
		backcolor_g.setValue( (vv.backcolor/256)%256) ;
		backcolor_b.setValue( vv.backcolor%256) ;

		maxloadline.setString( ""+vv.maxloadline) ;
		editmaxline.setString( ""+vv.editmaxline/1024) ;

		paragraphenter.setSelectedIndex( getYesNoDigit( vv.paragraphenter), true) ;
		keepbl.setSelectedIndex( getYesNoDigit( vv.keepbl), true) ;
		tategaki.setSelectedIndex( getYesNoDigit( vv.tategaki), true) ;


		switch( vv.font.getSize()){
			case Font.SIZE_LARGE:
				fontsize.setSelectedIndex( 2, true) ;
				break;
			case Font.SIZE_MEDIUM:
				fontsize.setSelectedIndex( 1, true) ;
				break;
			case Font.SIZE_SMALL:
			default :
				fontsize.setSelectedIndex( 0, true) ;
				break;
		}
		return ;
	}

	public void commandAction( Command cmd, Displayable d){
		if(cmd != List.SELECT_COMMAND){
			switch( cmd.getPriority()){
				case  19 :
					if( checkColor()){
						List lt = new List("PIƔwi̐F߂̂ŏFɐݒ肵܂I", Choice.IMPLICIT) ;
						lt.append("[[cOB", null) ;
						lt.setCommandListener(this) ;
						Display.getDisplay(vv.mld).setCurrent(lt) ;
						textcolor_r.setValue(0);textcolor_g.setValue(0);textcolor_b.setValue(0);;
						backcolor_r.setValue(255);backcolor_g.setValue(255);backcolor_b.setValue(255);
						return ;
					}
					break ;
				case  18 :
					Display.getDisplay(vv.mld).setCurrent(vv) ;
					vv.blOn() ;
					return ;
				default :
					return ;
			}
		}
		fixConfig() ;
//		vv.saveConfig();
		vv.loadFile();
		Display.getDisplay(vv.mld).setCurrent(vv) ;
		return ;
	}

	private void fixConfig(){
		try{
			vv.maxloadline = Integer.parseInt( maxloadline.getString()) ;
			if( vv.maxloadline>=100000 || vv.maxloadline < 1000){
				vv.maxloadline = 14999 ;
			}
		} catch( Exception e){
			vv.maxloadline = 14999 ;
		}

		try{
			vv.editmaxline = Integer.parseInt( editmaxline.getString()) ;
			if( vv.editmaxline>120 || vv.editmaxline < 10){
				vv.editmaxline = 40960 ;
			}
			vv.editmaxline *= 1024 ;
		} catch( Exception e){
			vv.editmaxline = 40960*1024 ;
		}

		vv.textcolor = (textcolor_r.getValue()*256+textcolor_g.getValue())*256+textcolor_b.getValue() ;
		vv.backcolor = (backcolor_r.getValue()*256+backcolor_g.getValue())*256+backcolor_b.getValue() ;

		vv.paragraphenter = getDigitYesNo( paragraphenter.getSelectedIndex()) ;
		vv.keepbl = getDigitYesNo( keepbl.getSelectedIndex()) ;
		vv.tategaki = getDigitYesNo( tategaki.getSelectedIndex()) ;

		switch(fontsize.getSelectedIndex()){
			case  0 :
			default :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_SMALL) ;
				break ;
			case  1 :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_MEDIUM) ;
				break ;
			case  2 :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_LARGE) ;
				break ;
		}
		vv.lineh = lineh.getValue() +vv.font.getHeight() ;
		vv.setMaxline() ;
		return ;
	}
	private boolean checkColor(){
		if( Math.abs(textcolor_r.getValue()-backcolor_r.getValue())+Math.abs(textcolor_g.getValue()-backcolor_g.getValue())+Math.abs(textcolor_b.getValue()-backcolor_b.getValue()) < 64){
			return  true ;
		} else {
			return  false ;
		}
	}
	private int getYesNoDigit( boolean base){
		if( base){
			return  0 ;
		} else {
			return  1 ;
		}
	}
	private boolean getDigitYesNo( int base){
		if( base==1){
			return  false ;
		} else {
			return  true ;
		}
	}
}
